Summary:        GNU Linear Programming Kit
Name:           glpk
Version:        5.0
Release:        3%{?dist}
License:        GPL-3.0-or-later AND MIT
URL:            https://www.gnu.org/software/glpk/glpk.html
Source0:        https://ftp.gnu.org/gnu/glpk/glpk-%{version}.tar.gz

Patch3000:      %{name}-4.65-unbundle-zlib.patch
Patch3001:      %{name}-4.65-unbundle-suitesparse.patch
Patch3002:      %{name}-4.65-alias.patch

BuildRequires:  autoconf automake libtool gmp-devel gnupg2 make pkgconfig(libiodbc) pkgconfig(mariadb)
BuildRequires:  suitesparse-devel pkgconfig(zlib)
Provides:       bundled(minisat) = 1.14.1

%description
The GLPK (GNU Linear Programming Kit) package is intended for solving large-scale linear programming
(LP), mixed integer programming (MIP), and other related problems. It is a set of routines written
in ANSI C and organized in the form of a callable library.

GLPK supports the GNU MathProg language, which is a subset of the AMPL language.

The GLPK package includes the following main components:

 * Revised simplex method.
 * Primal-dual interior point method.
 * Branch-and-bound method.
 * Translator for GNU MathProg.
 * Application program interface (API).
 * Stand-alone LP/MIP solver. 

%package devel
Summary:        Development headers and files for GLPK
Requires:       %{name} = %{version}-%{release}

%description devel
The glpk-devel package contains libraries and headers for developing applications which use GLPK
(GNU Linear Programming Kit).

%package utils
Summary:        GLPK-related utilities and examples
Requires:       %{name} = %{version}-%{release}

%description utils
The glpk-utils package contains the standalone solver program glpsol that uses GLPK (GNU Linear Programming Kit).

%prep
%autosetup -n %{name}-%{version} -p1

rm -fr src/{amd,colamd,zlib}

%build
export LIBS=-ldl

autoreconf -ifs

%configure --disable-static --with-gmp \
           --enable-dl=dlfcn --enable-odbc --enable-mysql
 sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
     -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
     -e 's|CC="\(g..\)"|CC="\1 -Wl,--as-needed"|' \
     -i libtool
%make_build

%install
make install prefix=%{buildroot}%{_prefix} \
    bindir=%{buildroot}%{_bindir} libdir=%{buildroot}%{_libdir} \
    includedir=%{buildroot}%{_includedir}

%check
export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:%{buildroot}%{_libdir}"
make check
rm -Rf examples/{.deps,.libs,Makefile*,glpsol,glpsol.o} doc/*.tex

%files
%license COPYING
%doc README
%{_libdir}/libglpk.so.40*
%exclude %{_libdir}/*.la

%files devel
%doc ChangeLog AUTHORS NEWS
%doc doc examples
%{_includedir}/glpk.h
%{_libdir}/libglpk.so

%files utils
%{_bindir}/glpsol

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 18 2023 Shuo Wang <abushwang@tencent.com> - 5.0-1
- initial build
